Index: binaries/data/mods/public/simulation/ai/common-api-v3/gamestate.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/gamestate.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/gamestate.js	(Arbeitskopie)
@@ -1,3 +1,7 @@
+var API3 = function(m)
+{
+
+
 /**
  * Provides an API for the rest of the AI scripts to query the world state at a
  * higher level than the raw data.
@@ -2,3 +6,3 @@
  */
-var GameState = function() {
+m.GameState = function() {
 	this.ai = null; // must be updated by the AIs.
@@ -10,7 +14,7 @@
 	this.turnCache = {};
 };
 
-GameState.prototype.init = function(SharedScript, state, player) {
+m.GameState.prototype.init = function(SharedScript, state, player) {
 	this.sharedScript = SharedScript;
 	this.EntCollecNames = SharedScript._entityCollectionsName;
 	this.EntCollec = SharedScript._entityCollections;
@@ -23,7 +27,7 @@
 	this.techModifications = SharedScript._techModifications[this.player];
 };
 
-GameState.prototype.update = function(SharedScript, state) {
+m.GameState.prototype.update = function(SharedScript, state) {
 	this.sharedScript = SharedScript;
 	this.EntCollecNames = SharedScript._entityCollectionsName;
 	this.EntCollec = SharedScript._entityCollections;
@@ -39,7 +43,7 @@
 	this.turnCache = {};
 };
 
-GameState.prototype.updatingCollection = function(id, filter, collection, allowQuick){
+m.GameState.prototype.updatingCollection = function(id, filter, collection, allowQuick){
 	// automatically add the player ID
 	id = this.player + "-" + id;
 	if (!this.EntCollecNames[id]){
@@ -56,7 +60,7 @@
 	
 	return this.EntCollecNames[id];
 };
-GameState.prototype.destroyCollection = function(id){
+m.GameState.prototype.destroyCollection = function(id){
 	// automatically add the player ID
 	id = this.player + "-" + id;
 	
@@ -65,7 +69,7 @@
 		delete this.EntCollecNames[id];
 	}
 };
-GameState.prototype.getEC = function(id){
+m.GameState.prototype.getEC = function(id){
 	// automatically add the player ID
 	id = this.player + "-" + id;
 
@@ -74,7 +78,7 @@
 	return undefined;
 };
 
-GameState.prototype.updatingGlobalCollection = function(id, filter, collection, allowQuick) {
+m.GameState.prototype.updatingGlobalCollection = function(id, filter, collection, allowQuick) {
 	if (!this.EntCollecNames[id]){
 		if (collection !== undefined)
 			this.EntCollecNames[id] = collection.filter(filter);
@@ -88,21 +92,21 @@
 	
 	return this.EntCollecNames[id];
 };
-GameState.prototype.destroyGlobalCollection = function(id)
+m.GameState.prototype.destroyGlobalCollection = function(id)
 {
 	if (this.EntCollecNames[id] !== undefined){
 		this.sharedScript.removeUpdatingEntityCollection(this.EntCollecNames[id]);
 		delete this.EntCollecNames[id];
 	}
 };
-GameState.prototype.getGEC = function(id)
+m.GameState.prototype.getGEC = function(id)
 {
 	if (this.EntCollecNames[id] !== undefined)
 		return this.EntCollecNames[id];
 	return undefined;
 };
 
-GameState.prototype.currentPhase = function()
+m.GameState.prototype.currentPhase = function()
 {
 	if (this.isResearched("phase_city"))
 		return 3;
@@ -113,30 +117,30 @@
 	return 0;
 };
 
-GameState.prototype.townPhase = function()
+m.GameState.prototype.townPhase = function()
 {
 	if (this.playerData.civ == "athen")
 		return "phase_town_athen";
 	return "phase_town_generic";
 };
 
-GameState.prototype.cityPhase = function()
+m.GameState.prototype.cityPhase = function()
 {
 	return "phase_city_generic";
 };
 
-GameState.prototype.isResearched = function(template)
+m.GameState.prototype.isResearched = function(template)
 {
 	return this.playerData.researchedTechs[template] !== undefined;
 };
 // true if started or queued
-GameState.prototype.isResearching = function(template)
+m.GameState.prototype.isResearching = function(template)
 {
 	return (this.playerData.researchStarted[template] !== undefined || this.playerData.researchQueued[template] !== undefined);
 };
 
 // this is an absolute check that doesn't check if we have a building to research from.
-GameState.prototype.canResearch = function(techTemplateName, noRequirementCheck)
+m.GameState.prototype.canResearch = function(techTemplateName, noRequirementCheck)
 {
 	var template = this.getTemplate(techTemplateName);
 	if (!template)
@@ -170,7 +174,7 @@
 
 // Private function for checking a set of requirements is met
 // basically copies TechnologyManager's
-GameState.prototype.checkTechRequirements = function (reqs)
+m.GameState.prototype.checkTechRequirements = function (reqs)
 {
 	// If there are no requirements then all requirements are met
 	if (!reqs)
@@ -229,73 +233,73 @@
 };
 
 
-GameState.prototype.getTimeElapsed = function()
+m.GameState.prototype.getTimeElapsed = function()
 {
 	return this.timeElapsed;
 };
 
-GameState.prototype.getTemplate = function(type)
+m.GameState.prototype.getTemplate = function(type)
 {
 	if (this.techTemplates[type] !== undefined)
-		return new Technology(this.techTemplates, type);
+		return new m.Technology(this.techTemplates, type);
 	
 	if (!this.templates[type])
 		return null;
 	
-	return new EntityTemplate(this.templates[type], this.techModifications);
+	return new m.EntityTemplate(this.templates[type], this.techModifications);
 };
 
-GameState.prototype.applyCiv = function(str) {
+m.GameState.prototype.applyCiv = function(str) {
 	return str.replace(/\{civ\}/g, this.playerData.civ);
 };
 
-GameState.prototype.civ = function() {
+m.GameState.prototype.civ = function() {
 	return this.playerData.civ;
 };
 
 /**
  * @returns {Resources}
  */
-GameState.prototype.getResources = function() {
-	return new Resources(this.playerData.resourceCounts);
+m.GameState.prototype.getResources = function() {
+	return new m.Resources(this.playerData.resourceCounts);
 };
 
-GameState.prototype.getMap = function() {
+m.GameState.prototype.getMap = function() {
 	return this.sharedScript.passabilityMap;
 };
 
-GameState.prototype.getPopulation = function() {
+m.GameState.prototype.getPopulation = function() {
 	return this.playerData.popCount;
 };
 
-GameState.prototype.getPopulationLimit = function() {
+m.GameState.prototype.getPopulationLimit = function() {
 	return this.playerData.popLimit;
 };
 
-GameState.prototype.getPopulationMax = function() {
+m.GameState.prototype.getPopulationMax = function() {
 	return this.playerData.popMax;
 };
 
-GameState.prototype.getPassabilityClassMask = function(name) {
+m.GameState.prototype.getPassabilityClassMask = function(name) {
 	if (!(name in this.sharedScript.passabilityClasses)){
 		error("Tried to use invalid passability class name '" + name + "'");
 	}
 	return this.sharedScript.passabilityClasses[name];
 };
 
-GameState.prototype.getPlayerID = function() {
+m.GameState.prototype.getPlayerID = function() {
 	return this.player;
 };
 
-GameState.prototype.isPlayerAlly = function(id) {
+m.GameState.prototype.isPlayerAlly = function(id) {
 	return this.playerData.isAlly[id];
 };
 
-GameState.prototype.isPlayerEnemy = function(id) {
+m.GameState.prototype.isPlayerEnemy = function(id) {
 	return this.playerData.isEnemy[id];
 };
 
-GameState.prototype.getEnemies = function(){
+m.GameState.prototype.getEnemies = function(){
 	var ret = [];
 	for (var i in this.playerData.isEnemy){
 		if (this.playerData.isEnemy[i]){
@@ -305,7 +309,7 @@
 	return ret;
 };
 
-GameState.prototype.isEntityAlly = function(ent) {
+m.GameState.prototype.isEntityAlly = function(ent) {
 	if (ent && ent.owner && (typeof ent.owner) === "function"){
 		return this.playerData.isAlly[ent.owner()];
 	} else if (ent && ent.owner){
@@ -314,7 +318,7 @@
 	return false;
 };
 
-GameState.prototype.isEntityEnemy = function(ent) {
+m.GameState.prototype.isEntityEnemy = function(ent) {
 	if (ent && ent.owner && (typeof ent.owner) === "function"){
 		return this.playerData.isEnemy[ent.owner()];
 	} else if (ent && ent.owner){
@@ -323,7 +327,7 @@
 	return false;
 };
  
-GameState.prototype.isEntityOwn = function(ent) {
+m.GameState.prototype.isEntityOwn = function(ent) {
 	if (ent && ent.owner && (typeof ent.owner) === "function"){
 		return ent.owner() == this.player;
 	} else if (ent && ent.owner){
@@ -332,11 +336,11 @@
 	return false;
 };
 
-GameState.prototype.getOwnEntities = function() {
-	return this.updatingCollection("own-entities", Filters.byOwner(this.player));
+m.GameState.prototype.getOwnEntities = function() {
+	return this.updatingCollection("own-entities", m.Filters.byOwner(this.player));
 };
 
-GameState.prototype.getEnemyEntities = function() {
+m.GameState.prototype.getEnemyEntities = function() {
 	var diplomacyChange = false;
 	var enemies = this.getEnemies();
 	if (this.enemies){
@@ -351,17 +355,17 @@
 		}
 	}
 	if (diplomacyChange || !this.enemies){
-		return this.updatingCollection("enemy-entities", Filters.byOwners(enemies));
+		return this.updatingCollection("enemy-entities", m.Filters.byOwners(enemies));
 		this.enemies = enemies;
 	}
 	return this.getEC("enemy-entities");
 };
 
-GameState.prototype.getEntities = function() {
+m.GameState.prototype.getEntities = function() {
 	return this.entities;
 };
 
-GameState.prototype.getEntityById = function(id){
+m.GameState.prototype.getEntityById = function(id){
 	if (this.entities._entities[id]) {
 		return this.entities._entities[id];
 	}else{
@@ -370,37 +374,37 @@
 	return undefined;
 };
 
-GameState.prototype.getOwnEntitiesByMetadata = function(key, value, maintain){
+m.GameState.prototype.getOwnEntitiesByMetadata = function(key, value, maintain){
 	if (maintain === true)
-		return this.updatingCollection(key + "-" + value, Filters.byMetadata(this.player, key, value),this.getOwnEntities());
-	return this.getOwnEntities().filter(Filters.byMetadata(this.player, key, value));
+		return this.updatingCollection(key + "-" + value, m.Filters.byMetadata(this.player, key, value),this.getOwnEntities());
+	return this.getOwnEntities().filter(m.Filters.byMetadata(this.player, key, value));
 };
 
-GameState.prototype.getOwnEntitiesByRole = function(role){
+m.GameState.prototype.getOwnEntitiesByRole = function(role){
 	return this.getOwnEntitiesByMetadata("role", role, true);
 };
 
-GameState.prototype.getOwnTrainingFacilities = function(){
-	return this.updatingCollection("own-training-facilities", Filters.byTrainingQueue(), this.getOwnEntities(), true);
+m.GameState.prototype.getOwnTrainingFacilities = function(){
+	return this.updatingCollection("own-training-facilities", m.Filters.byTrainingQueue(), this.getOwnEntities(), true);
 };
 
-GameState.prototype.getOwnResearchFacilities = function(){
-	return this.updatingCollection("own-research-facilities", Filters.byResearchAvailable(), this.getOwnEntities(), true);
+m.GameState.prototype.getOwnResearchFacilities = function(){
+	return this.updatingCollection("own-research-facilities", m.Filters.byResearchAvailable(), this.getOwnEntities(), true);
 };
 
-GameState.prototype.getOwnEntitiesByType = function(type, maintain){
-	var filter = Filters.byType(type);
+m.GameState.prototype.getOwnEntitiesByType = function(type, maintain){
+	var filter = m.Filters.byType(type);
 	if (maintain === true)
 		return this.updatingCollection("own-by-type-" + type, filter, this.getOwnEntities());
 	return this.getOwnEntities().filter(filter);
 
 };
 
-GameState.prototype.countEntitiesByType = function(type, maintain) {
+m.GameState.prototype.countEntitiesByType = function(type, maintain) {
 	return this.getOwnEntitiesByType(type, maintain).length;
 };
 
-GameState.prototype.countEntitiesAndQueuedByType = function(type) {
+m.GameState.prototype.countEntitiesAndQueuedByType = function(type) {
 	var count = this.countEntitiesByType(type, true);
 	
 	// Count building foundations
@@ -424,7 +428,7 @@
 	return count;
 };
 
-GameState.prototype.countFoundationsWithType = function(type) {
+m.GameState.prototype.countFoundationsWithType = function(type) {
 	var foundationType = "foundation|" + type;
 	var count = 0;
 	this.getOwnEntities().forEach(function(ent) {
@@ -435,11 +439,11 @@
 	return count;
 };
 
-GameState.prototype.countOwnEntitiesByRole = function(role) {
+m.GameState.prototype.countOwnEntitiesByRole = function(role) {
 	return this.getOwnEntitiesByRole(role).length;
 };
 
-GameState.prototype.countOwnEntitiesAndQueuedWithRole = function(role) {
+m.GameState.prototype.countOwnEntitiesAndQueuedWithRole = function(role) {
 	var count = this.countOwnEntitiesByRole(role);
 	
 	// Count entities in building production queues
@@ -452,7 +456,7 @@
 	return count;
 };
 
-GameState.prototype.countOwnQueuedEntitiesWithMetadata = function(data, value) {
+m.GameState.prototype.countOwnQueuedEntitiesWithMetadata = function(data, value) {
 	// Count entities in building production queues
 	var count = 0;
 	this.getOwnTrainingFacilities().forEach(function(ent) {
@@ -468,7 +472,7 @@
  * Find buildings that are capable of training the given unit type, and aren't
  * already too busy.
  */
-GameState.prototype.findTrainers = function(template) {
+m.GameState.prototype.findTrainers = function(template) {
 	var maxQueueLength = 3; // avoid tying up resources in giant training queues
 	
 	return this.getOwnTrainingFacilities().filter(function(ent) {
@@ -490,7 +494,7 @@
 /**
  * Find units that are capable of constructing the given building type.
  */
-GameState.prototype.findBuilders = function(template) {
+m.GameState.prototype.findBuilders = function(template) {
 	return this.getOwnEntities().filter(function(ent) {
 
 		var buildable = ent.buildableEntities();
@@ -505,7 +509,7 @@
  * Find buildings that are capable of researching the given tech, and aren't
  * already too busy.
  */
-GameState.prototype.findResearchers = function(templateName, noRequirementCheck) {
+m.GameState.prototype.findResearchers = function(templateName, noRequirementCheck) {
 	// let's check we can research the tech.
 	if (!this.canResearch(templateName, noRequirementCheck))
 		return [];
@@ -532,36 +536,36 @@
 	});
 };
 
-GameState.prototype.getOwnFoundations = function() {
-	return this.updatingCollection("ownFoundations", Filters.isFoundation(), this.getOwnEntities());
+m.GameState.prototype.getOwnFoundations = function() {
+	return this.updatingCollection("ownFoundations", m.Filters.isFoundation(), this.getOwnEntities());
 };
 
-GameState.prototype.getOwnDropsites = function(resource){
+m.GameState.prototype.getOwnDropsites = function(resource){
 	if (resource !== undefined)
-		return this.updatingCollection("dropsite-own-" + resource, Filters.isDropsite(resource), this.getOwnEntities(), true);
-	return this.updatingCollection("dropsite-own", Filters.isDropsite(), this.getOwnEntities(), true);
+		return this.updatingCollection("dropsite-own-" + resource, m.Filters.isDropsite(resource), this.getOwnEntities(), true);
+	return this.updatingCollection("dropsite-own", m.Filters.isDropsite(), this.getOwnEntities(), true);
 };
 
-GameState.prototype.getResourceSupplies = function(resource){
-	return this.updatingGlobalCollection("resource-" + resource, Filters.byResource(resource), this.getEntities(), true);
+m.GameState.prototype.getResourceSupplies = function(resource){
+	return this.updatingGlobalCollection("resource-" + resource, m.Filters.byResource(resource), this.getEntities(), true);
 };
 
-GameState.prototype.getEntityLimits = function() {
+m.GameState.prototype.getEntityLimits = function() {
 	return this.playerData.entityLimits;
 };
 
-GameState.prototype.getEntityCounts = function() {
+m.GameState.prototype.getEntityCounts = function() {
 	return this.playerData.entityCounts;
 };
 
 // Checks whether the maximum number of buildings have been cnstructed for a certain catergory
-GameState.prototype.isEntityLimitReached = function(category) {
+m.GameState.prototype.isEntityLimitReached = function(category) {
 	if(this.playerData.entityLimits[category] === undefined || this.playerData.entityCounts[category] === undefined)
 		return false;
 	return (this.playerData.entityCounts[category] >= this.playerData.entityLimits[category]);
 };
 
-GameState.prototype.findTrainableUnits = function(classes){
+m.GameState.prototype.findTrainableUnits = function(classes){
 	var allTrainable = [];
 	this.getOwnEntities().forEach(function(ent) {
 		var trainable = ent.trainableEntities();
@@ -593,7 +597,7 @@
 // Return all techs which can currently be researched
 // Does not factor cost.
 // If there are pairs, both techs are returned.
-GameState.prototype.findAvailableTech = function() {
+m.GameState.prototype.findAvailableTech = function() {
 	
 	var allResearchable = [];
 	this.getOwnEntities().forEach(function(ent) {
@@ -625,16 +629,20 @@
 };
 
 // defcon utilities
-GameState.prototype.timeSinceDefconChange = function() {
+m.GameState.prototype.timeSinceDefconChange = function() {
 	return this.getTimeElapsed()-this.ai.defconChangeTime;
 };
-GameState.prototype.setDefcon = function(level,force) {
+m.GameState.prototype.setDefcon = function(level,force) {
 	if (this.ai.defcon >= level || force) {
 		this.ai.defcon = level;
 		this.ai.defconChangeTime = this.getTimeElapsed();
 	}
 };
-GameState.prototype.defcon = function() {
+m.GameState.prototype.defcon = function() {
 	return this.ai.defcon;
 };
 
+return m;
+
+}(API3);
+
Index: binaries/data/mods/public/simulation/ai/common-api-v3/resources.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/resources.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/resources.js	(Arbeitskopie)
@@ -1,4 +1,7 @@
-function Resources(amounts, population) {
+var API3 = function(m)
+{
+
+m.Resources = function(amounts, population) {
 	if (amounts === undefined) {
 		amounts = {
 			food : 0,
@@ -19,9 +22,9 @@
 	}
 }
 
-Resources.prototype.types = [ "food", "wood", "stone", "metal" ];
+m.Resources.prototype.types = [ "food", "wood", "stone", "metal" ];
 
-Resources.prototype.reset = function() {
+m.Resources.prototype.reset = function() {
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
 		this[t] = 0;
@@ -29,7 +32,7 @@
 	this.population = 0;
 };
 
-Resources.prototype.canAfford = function(that) {
+m.Resources.prototype.canAfford = function(that) {
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
 		if (this[t] < that[t]) {
@@ -39,7 +42,7 @@
 	return true;
 };
 
-Resources.prototype.add = function(that) {
+m.Resources.prototype.add = function(that) {
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
 		this[t] += that[t];
@@ -47,7 +50,7 @@
 	this.population += that.population;
 };
 
-Resources.prototype.subtract = function(that) {
+m.Resources.prototype.subtract = function(that) {
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
 		this[t] -= that[t];
@@ -55,7 +58,7 @@
 	this.population += that.population;
 };
 
-Resources.prototype.multiply = function(n) {
+m.Resources.prototype.multiply = function(n) {
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
 		this[t] *= n;
@@ -63,7 +66,7 @@
 	this.population *= n;
 };
 
-Resources.prototype.toInt = function() {
+m.Resources.prototype.toInt = function() {
 	var sum = 0;
 	for ( var tKey in this.types) {
 		var t = this.types[tKey];
@@ -72,3 +75,7 @@
 	sum += this.population * 50; // based on typical unit costs
 	return sum;
 };
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/technology.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/technology.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/technology.js	(Arbeitskopie)
@@ -1,6 +1,9 @@
+var API3 = function(m)
+{
+
 // Wrapper around a technology template
 
-function Technology(allTemplates, templateName)
+m.Technology = function(allTemplates, templateName)
 {
 	this._templateName = templateName;
 	var template = allTemplates[templateName];
@@ -20,7 +23,7 @@
 	this._techTemplates = allTemplates;
 }
 // returns generic, or specific if civ provided.
-Technology.prototype.name = function(civ)
+m.Technology.prototype.name = function(civ)
 {
 	if (civ === undefined)
 	{
@@ -34,37 +37,37 @@
 	}
 };
 
-Technology.prototype.pairDef = function()
+m.Technology.prototype.pairDef = function()
 {
 	return this._definesPair;
 };
 // in case this defines a pair only, returns the two paired technologies.
-Technology.prototype.getPairedTechs = function()
+m.Technology.prototype.getPairedTechs = function()
 {
 	if (!this._definesPair)
 		return undefined;
 	
-	var techOne = new Technology(this._techTemplates, this._template.top);
-	var techTwo = new Technology(this._techTemplates, this._template.bottom);
+	var techOne = new m.Technology(this._techTemplates, this._template.top);
+	var techTwo = new m.Technology(this._techTemplates, this._template.bottom);
 	
 	return [techOne,techTwo];
 };
 
-Technology.prototype.pair = function()
+m.Technology.prototype.pair = function()
 {
 	if (!this._isPair)
 		return undefined;
 	return this._template.pair;
 };
 
-Technology.prototype.pairedWith = function()
+m.Technology.prototype.pairedWith = function()
 {
 	if (!this._isPair)
 		return undefined;
 	return this._pairedWith;
 };
 
-Technology.prototype.cost = function()
+m.Technology.prototype.cost = function()
 {
 	if (!this._template.cost)
 		return undefined;
@@ -72,49 +75,49 @@
 };
 
 // seconds
-Technology.prototype.researchTime = function()
+m.Technology.prototype.researchTime = function()
 {
 	if (!this._template.researchTime)
 		return undefined;
 	return this._template.researchTime;
 };
 
-Technology.prototype.requirements = function()
+m.Technology.prototype.requirements = function()
 {
 	if (!this._template.requirements)
 		return undefined;
 	return this._template.requirements;
 };
 
-Technology.prototype.autoResearch = function()
+m.Technology.prototype.autoResearch = function()
 {
 	if (!this._template.autoResearch)
 		return undefined;
 	return this._template.autoResearch;
 };
 
-Technology.prototype.supersedes = function()
+m.Technology.prototype.supersedes = function()
 {
 	if (!this._template.supersedes)
 		return undefined;
 	return this._template.supersedes;
 };
 
-Technology.prototype.modifications = function()
+m.Technology.prototype.modifications = function()
 {
 	if (!this._template.modifications)
 		return undefined;
 	return this._template.modifications;
 };
 
-Technology.prototype.affects = function()
+m.Technology.prototype.affects = function()
 {
 	if (!this._template.affects)
 		return undefined;
 	return this._template.affects;
 };
 
-Technology.prototype.isAffected = function(classes)
+m.Technology.prototype.isAffected = function(classes)
 {
 	if (!this._template.affects)
 		return false;
@@ -136,3 +139,7 @@
 	}
 	return false;
 };
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/baseAI.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/baseAI.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/baseAI.js	(Arbeitskopie)
@@ -1,19 +1,22 @@
 var PlayerID = -1;
 
-function BaseAI(settings)
+var API3 = (function() {
+
+var m = {};
+
+m.BaseAI = function(settings)
 {
 	if (!settings)
 		return;
 
 	this.player = settings.player;
-	PlayerID = this.player;
 
 	// played turn, in case you don't want the AI to play every turn.
 	this.turn = 0;
-}
+};
 
 //Return a simple object (using no classes etc) that will be serialized into saved games
-BaseAI.prototype.Serialize = function()
+m.BaseAI.prototype.Serialize = function()
 {
 	// TODO: ought to get the AI script subclass to serialize its own state
 	// TODO: actually this is part of a larger reflection on wether AIs should or not.
@@ -22,15 +25,16 @@
 
 //Called after the constructor when loading a saved game, with 'data' being
 //whatever Serialize() returned
-BaseAI.prototype.Deserialize = function(data, sharedScript)
+m.BaseAI.prototype.Deserialize = function(data, sharedScript)
 {
 	// TODO: ought to get the AI script subclass to deserialize its own state
 	// TODO: actually this is part of a larger reflection on wether AIs should or not.
 	this.isDeserialized = true;
 };
 
-BaseAI.prototype.Init = function(state, sharedAI)
+m.BaseAI.prototype.Init = function(state, playerID, sharedAI)
 {
+	PlayerID = playerID;
 	// define some references
 	this.entities = sharedAI.entities;
 	this.templates = sharedAI.templates;
@@ -43,7 +47,7 @@
 	this.techModifications = sharedAI._techModifications[this.player];
 	this.playerData = sharedAI.playersData[this.player];
 	
-	this.gameState = sharedAI.gameState[PlayerID];
+	this.gameState = sharedAI.gameState[this.player];
 	this.gameState.ai = this;
 	this.sharedScript = sharedAI;
 	
@@ -52,13 +56,14 @@
 	this.CustomInit(this.gameState, this.sharedScript);
 }
 
-BaseAI.prototype.CustomInit = function()
+m.BaseAI.prototype.CustomInit = function()
 {	// AIs override this function
 };
 
-BaseAI.prototype.HandleMessage = function(state, sharedAI)
+m.BaseAI.prototype.HandleMessage = function(state, playerID, sharedAI)
 {
 	this.events = sharedAI.events;
+	PlayerID = playerID;
 	
 	if (this.isDeserialized && this.turn !== 0)
 	{
@@ -70,20 +75,24 @@
 	this.OnUpdate(sharedAI);
 };
 
-BaseAI.prototype.OnUpdate = function()
+m.BaseAI.prototype.OnUpdate = function()
 {	// AIs override this function
 };
 
-BaseAI.prototype.chat = function(message)
+m.BaseAI.prototype.chat = function(message)
 {
-	Engine.PostCommand({"type": "chat", "message": message});
+	Engine.PostCommand(PlayerID,{"type": "chat", "message": message});
 };
-BaseAI.prototype.chatTeam = function(message)
+m.BaseAI.prototype.chatTeam = function(message)
 {
-	Engine.PostCommand({"type": "chat", "message": "/team " +message});
+	Engine.PostCommand(PlayerID,{"type": "chat", "message": "/team " +message});
 };
-BaseAI.prototype.chatEnemies = function(message)
+m.BaseAI.prototype.chatEnemies = function(message)
 {
-	Engine.PostCommand({"type": "chat", "message": "/enemy " +message});
+	Engine.PostCommand(PlayerID,{"type": "chat", "message": "/enemy " +message});
 };
 
+return m;
+
+}());
+
Index: binaries/data/mods/public/simulation/ai/common-api-v3/map-module.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/map-module.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/map-module.js	(Arbeitskopie)
@@ -1,3 +1,6 @@
+var API3 = function(m)
+{
+
 /* The map module.
  * Copied with changes from QuantumState's original for qBot, it's a component for storing 8 bit values.
  */
@@ -2,5 +5,4 @@
 
-const TERRITORY_PLAYER_MASK = 0x3F;
-
-function Map(sharedScript, originalMap, actualCopy){
+// The function needs to be named too because of the copyConstructor functionality
+m.Map = function Map(sharedScript, originalMap, actualCopy){
 	// get the map to find out the correct dimensions
@@ -25,19 +27,19 @@
 	this.cellSize = 4;
 }
 
-Map.prototype.setMaxVal = function(val){
+m.Map.prototype.setMaxVal = function(val){
 	this.maxVal = val;
 };
 
-Map.prototype.gamePosToMapPos = function(p){
+m.Map.prototype.gamePosToMapPos = function(p){
 	return [Math.floor(p[0]/this.cellSize), Math.floor(p[1]/this.cellSize)];
 };
 
-Map.prototype.point = function(p){
+m.Map.prototype.point = function(p){
 	var q = this.gamePosToMapPos(p);
 	return this.map[q[0] + this.width * q[1]];
 };
-Map.prototype.addInfluence = function(cx, cy, maxDist, strength, type) {
+m.Map.prototype.addInfluence = function(cx, cy, maxDist, strength, type) {
 	strength = strength ? +strength : +maxDist;
 	type = type ? type : 'linear';
 	
@@ -90,7 +92,7 @@
 	}
 };
 
-Map.prototype.multiplyInfluence = function(cx, cy, maxDist, strength, type) {
+m.Map.prototype.multiplyInfluence = function(cx, cy, maxDist, strength, type) {
 	strength = strength ? +strength : +maxDist;
 	type = type ? type : 'constant';
 	
@@ -145,7 +147,7 @@
 };
 
 // doesn't check for overflow.
-Map.prototype.setInfluence = function(cx, cy, maxDist, value) {
+m.Map.prototype.setInfluence = function(cx, cy, maxDist, value) {
 	value = value ? value : 0;
 	
 	var x0 = Math.max(0, cx - maxDist);
@@ -166,7 +168,7 @@
 	}
 };
 
-Map.prototype.sumInfluence = function(cx, cy, radius){
+m.Map.prototype.sumInfluence = function(cx, cy, radius){
 	var x0 = Math.max(0, cx - radius);
 	var y0 = Math.max(0, cy - radius);
 	var x1 = Math.min(this.width, cx + radius);
@@ -192,7 +194,7 @@
  * neighbours' values. (If the grid is initialised with 0s and 65535s or 255s, the
  * result of each cell is its Manhattan distance to the nearest 0.)
  */
-Map.prototype.expandInfluences = function(maximum, map) {
+m.Map.prototype.expandInfluences = function(maximum, map) {
 	var grid = this.map;
 	if (map !== undefined)
 		grid = map;
@@ -252,7 +254,7 @@
 	}
 };
 
-Map.prototype.findBestTile = function(radius, obstructionTiles){
+m.Map.prototype.findBestTile = function(radius, obstructionTiles){
 	// Find the best non-obstructed tile
 	var bestIdx = 0;
 	var bestVal = -1;
@@ -269,14 +271,14 @@
 	return [bestIdx, bestVal];
 };
 // Multiplies current map by the parameter map pixelwise
-Map.prototype.multiply = function(map, onlyBetter, divider, maxMultiplier){
+m.Map.prototype.multiply = function(map, onlyBetter, divider, maxMultiplier){
 	for (var i = 0; i < this.length; ++i){
 		if (map.map[i]/divider > 1)
 			this.map[i] = Math.min(maxMultiplier*this.map[i], this.map[i] * (map.map[i]/divider));
 	}
 };
 // add to current map by the parameter map pixelwise
-Map.prototype.add = function(map){
+m.Map.prototype.add = function(map){
 	for (var i = 0; i < this.length; ++i) {
 		if (this.map[i] + map.map[i] < 0)
 			this.map[i] = 0;
@@ -287,8 +289,12 @@
 	}
 };
 
-Map.prototype.dumpIm = function(name, threshold){
+m.Map.prototype.dumpIm = function(name, threshold){
 	name = name ? name : "default.png";
 	threshold = threshold ? threshold : this.maxVal;
 	Engine.DumpImage(name, this.map, this.width, this.height, threshold);
 };
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/class.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/class.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/class.js	(Arbeitskopie)
@@ -1,3 +1,5 @@
+var API3 = function(m)
+{
 /**
  * Provides a nicer syntax for defining classes,
  * with support for OO-style inheritance.
@@ -2,3 +4,3 @@
  */
-function Class(data)
+m.Class = function(data)
 {
@@ -34,3 +36,7 @@
 print((new B).foo+" "+(new B).bar+"\n");
 print((new C).foo+" "+(new C).bar+"\n");
 //*/
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/filters.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/filters.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/filters.js	(Arbeitskopie)
@@ -1,4 +1,7 @@
-var Filters = {
+var API3 = function(m)
+{
+
+m.Filters = {
 	byType: function(type){
 		return {"func" : function(ent){
 			return ent.templateName() === type;
@@ -169,7 +172,7 @@
 			if (ent.position() === undefined){
 				return false;
 			}else{
-				return (SquareVectorDistance(startPoint, ent.position()) < dist*dist);
+				return (m.SquareVectorDistance(startPoint, ent.position()) < dist*dist);
 			}
 		},
 		"dynamicProperties": ['position']};
@@ -181,7 +184,7 @@
 			if (!ent.position()){
 				return false;
 			}else{
-				return (SquareVectorDistance(startPoint, ent.position()) < dist*dist);
+				return (m.SquareVectorDistance(startPoint, ent.position()) < dist*dist);
 			}
 		},
 		"dynamicProperties": []};
@@ -238,3 +241,8 @@
 		"dynamicProperties": []};
 	}
 };
+
+return m;
+
+}(API3);
+
